# This is a perl script
##########################################################################
#    This program is the CONFIDENTIAL and PROPRIETARY property
#    of Mainsoft(R) Corporation. Any unauthorized use, reproduction 
#    or transfer of this computer program is strictly prohibited.
#
#    Copyright (c) 1991-1998 Mainsoft Corporation.
#    This is an unpublished work, and is subject to limited distribution
#    and restricted disclosure only. ALL RIGHTS ESERVED.
#
##########################################################################

my $bAutoLoad = 0;

if( $ARGV[0] eq "-autoload" ) 
{
    shift @ARGV;
    $bAutoLoad = 1;
    FixExcept( @ARGV );
}


sub AUTOLOAD 
{
    print "      Uncknown function $AUTOLOAD called at line ".__LINE__.".\n";
    print "      Defaulting to FixExcept.\n";
    FixExcept( @_ );
}


sub FixExcept 
{
    Fix("\\b__except\\b", " __endexcept; ", @_);
    Fix("\\b__finally\\b", " __endfinally; ", @_);   
    Fix("\\b_except\\b", " _endexcept; ", @_);
    Fix("\\b_finally\\b", " _endfinally; ", @_);    
}

sub Fix
{
    $search_for = shift;
    $add = shift;
    while ($file= pop(@_)) 
    {
	next if ((! -f $file) || (-l $file));
	
	open(FROM_FILE,"<$file");
	open(TO_FILE,">$file.out");
	$was_modified = 0;
	while($Line = <FROM_FILE>) 
	{
	    if ($Line =~ /$search_for/)
	    {
		$BracketCount = 0;
		$FirstFound = 0;
		$String = $';
		print TO_FILE $`, $&;
		do
		{
		    for($i=0; $i < length($String) ; $i++)
		    {
			if (chr(vec($String, $i, 8)) eq "{")
			{
			    $BracketCount++;
			    $FirstFound = 1;
			}
			if (chr(vec($String, $i, 8)) eq "}")
			{
			    $BracketCount--;
			    if( $BracketCount == 0 )
			    {
				print TO_FILE substr($String, 0, $i+1);
				print TO_FILE $add;
				#print TO_FILE substr($String, $i+1);
				seek(FROM_FILE, $i-length($String)+1, 1);
				$was_modified = 1;
				goto done;
			    }
			}
		    }
		    print TO_FILE $String;
		    $String = <FROM_FILE>;
		}
		while(1)
	    }
	    else
	    {
		print TO_FILE $Line;
	    }
done:
	}
	close (FROM_FILE);
	close (TO_FILE);
	if($was_modified)
	{
	    if( ! -z "$file.out" ) 
	    {
		rename( "$file.out", "$file" );
		print STDOUT "Fixed except and finally blocks $file\n" if $bAutoLoad;
	    }
	    else 
	    {
		print STDERR "Fix failed: couldn't create file of size " . ( -s $file ) . ". Please check your disk space.\n\n";
		unlink( "$file.out" );
	    }
	}
	else
	{
	    unlink("$file.out");
	}
    }
}

1;  # to satisfy the 'require' function
    
