#
# Perl script to list the shared libaries an executable image uses
#

do "$ENV{'MWHOME'}/lib/common-utilities.pl";

$file = shift(@ARGV);

if (($MWOS eq "sunos4") || ($MWOS eq "sunos5") || ($MWOS eq "linux") ) {
    $lslcommand = "ldd";
} elsif (($MWOS eq "osf1v2") || ($MWOS eq "osf1v4") || ($MWOS eq "irix53") ||
    ($MWOS eq "irix6")) {
    $lslcommand = "odump -Dl";
} elsif (($MWOS eq "ux9") || ($MWOS eq "ux10") || ($MWOS eq "ux11")) {
    $lslcommand = "chatr";
} elsif ($MWOS eq "aix4") {
    $lslcommand = "ldd";
} else {
    &FatalError("mwlsl - Unknown OS type", -1);
}

&ShowAndExecuteCommand("$lslcommand $file");
