# This is a perl script
foreach $file (@ARGV) {
	$ifile = "${file}.orig.headers";
	rename("$file", "$ifile") || die "Can't rename $file to $ifile\n";
	open (OFILE, ">$file") || die "Can't open output file $file\n";
	open (FILE, $ifile) || die "Can't open input file $ifile\n";
	while (<FILE>) {
	    if (/^(\s*#\s*include\s*[<"])([gG][lL][\/\\])([^"\s]+[>"])/) {
		print OFILE "${1}GL/${3}\n";
	    } else {
		print OFILE;
	    }
	}
	unlink($ifile);
	close(FILE);
	close(OFILE);
}

