#!/usr/local/bin/perl

# @(#) xlC preprocessor postprocessor for AIX4 mktyplib - yba
# $Header: /us32/atria/cc_convert/inc/mw/mw/lib/xlC2mktyplib.pl,v 1.2 1997/01/26 20:39:22 eyala Exp $
# First version by Jonathan Ben-Avraham for Mainsoft (Israel) Ltd. 29/VII/96

# This script massages the xlC preprocessor output into a form that
# mktyplib can handle without choking. This temporarily obviates the need
# to change the mktyplib code itself.

$PREPROP = 3;		# a file descriptor
$last_line = "";

# execute xlC with whatever arguments were passed to this script and
# redirect the output into the PREPROP file descriptor.
$CCPP = $ENV{CCPP};
open(PREPROP, "$CCPP @ARGV |");

while (<PREPROP>)
{
	if (/^\s*\/\//) {next;}				# skip C++ comment lines
	if (/^\s*$/) {next;}				# skip blank lines
	if (/^\s*[#]line\s[0-9]+$/) {next;}	# skip "#line nn" lines

#	Print only the last in a series of '#line nn "<filename>"' lines

	if (/[#]line/)
	{
		$last_line = $_;
	}
	else
	{
		if ($last_line ne "")
		{
			print $last_line;
			$last_line = "";
		}
		print $_;
	}
}
