#! /usr/local/bin/perl

my $env_script;
my $exec_dir = "";
my $executable = "";
my $exec_name = "";
my $exec_line = "";

while ($arg = shift @ARGV)
{
    if ($arg =~ /-exec_dir/)
    {
        $exec_dir=shift @ARGV; 
    }
    elsif($arg =~ /-exec/)
    {
        $executable=shift @ARGV; 
    	$exec_line .= " $executable";
    }
    else
    {
	$exec_line .= " $arg";
    }	
}

$exec_name = `basename $executable`;

if ($exec_dir eq "")
{
    $exec_dir = `dirname $executable`;
}

chomp($exec_dir);
chomp($exec_name);

sub CheckForFile{
    my ($file) = @_;
    if (-f $file){
        $env_script = $file;
        return 1;
    }
    return 0;
}

my $found=0;
if ($exec_name =~ /^(.*)\.exe/) {
    my $base = $1;
    $found=CheckForFile("$exec_dir/$base.init");
}

if(!$found){
    CheckForFile("$exec_dir/$exec_name.init") or
    CheckForFile("$exec_dir/init") or
    (print STDOUT "default_env_script: cannot find env_script\n" && exit(2));
}
my @cmd_line = ($env_script, $exec_line);
print STDOUT "default env_script found : $env_script\ncmd_line: @cmd_line\n";
exec(@cmd_line);


