
# usage: call  mwdebug or mwoptimized before calling this script.

$Home = $ENV{MWHOME};
do "$Home/lib/common-utilities.pl";
@libs = qw(
kernel32
mfcs400du
userpri
actxprxy
advapi32
atl
cards
comdlg32
comcat
comctl32
coolmisc
database
flocator
ftsrch
htmlhelp
imgutil
itircl
itss
jscript
mfc400d
mfc400du
mfc400s	
mfc400su
mfc42jpn
mfcs400d
mfcs400s
mfcs400su
mlang
mshtmdbg
mshtml	
mshtmlwb
mw32
mwicons
mwogl
mwsupl
ntrtl
ole2ui
ole32
oleaut32
olepro32
Perlocator
pngfilt
rcdll
riched32
rpcltccm
rpcltscm
rpcrt4
rpcssp
shdocvw
shell32
shlwapi
tcprops
testdll1
testdll2
tlsdll
url
urlmon
uuid
vbscript
wfsapi
wininet
winmm
wsock32
X11
);




sub find
{
    my($libname, $path_list) = @_;
    my ($sofile, $afile, $first);

    foreach $dir ( @$path_list ) {
	$sofile = "${dir}/lib$libname.$::lib_suffix";
	$afile = "$dir/lib$libname.a";

	if    ( -e $sofile ) { return $sofile; }
	elsif ( -e $afile  ) { return $afile;  }
	else                 { next;            }
    }   
    return ""; 
}

sub generate_libs
{
    foreach $lib (@libs){
	my $f = find($lib, \@::ld_lib_path);
	if ( $f )  {
	    $f =~ /(.*)\./;
	    if ( -e $f ) {
		`mwmklib -i$f -o$1 -noquiet`;
	    }
	}
	else {
	    print STDERR "lib: $lib was not built yet - please build it\n";
	}
    }
}


package main;
generate_libs();




